﻿using System.Collections.Generic;
using System.IO;

namespace Recombobulator.SR1Structures
{
    class DrMoveAniTex : SR1_Structure
    {
        int numAniTextures;
        SR1_StructureArrayPointer<DrMoveAniTexDestInfo> aniTexInfo = new SR1_StructureArrayPointer<DrMoveAniTexDestInfo>((parent) => (int)((DrMoveAniTex)parent).numAniTextures);

        public override void Read(SortedDictionary<uint, SR1_Structure> dictionary, BinaryReader reader, bool isMember, GoalTracker tracker)
        {
            Start = (uint)reader.BaseStream.Position;
            IsMember = isMember;

            if (!IsMember)
            {
                dictionary.Add(Start, this);
            }

            numAniTextures = reader.ReadInt32();

            if (numAniTextures > 0)
            {
                aniTexInfo.Offset = reader.ReadUInt32();
            }

            End = (uint)reader.BaseStream.Position;
        }
    }
}
