﻿using System.Collections.Generic;
using System.IO;

namespace Recombobulator.SR1Structures
{
    class EventPointers : SR1_Structure
    {
        int numPuzzles;
        SR1_PointerArray<Event> eventInstances = new SR1_PointerArray<Event>(0, true);

        public override void Read(SortedDictionary<uint, SR1_Structure> dictionary, BinaryReader reader, bool isMember, GoalTracker tracker)
        {
            Start = (uint)reader.BaseStream.Position;
            IsMember = isMember;

            if (!IsMember)
            {
                dictionary.Add(Start, this);
            }

            numPuzzles = reader.ReadInt32();

            eventInstances = new SR1_PointerArray<Event>(numPuzzles, true);
            eventInstances.Read(dictionary, reader, true, tracker);

            End = (uint)reader.BaseStream.Position;
        }
    }
}
