﻿using System;
using System.Reflection;

namespace Recombobulator.SR1Structures
{
    class Level : SR1_Structure
    {
        // Use      //.*\r?\n     to search and remove comments.

        SR1_Pointer<Terrain> terrain = new SR1_Pointer<Terrain>(true);
        SR1_Pointer<LightList> lightList = new SR1_Pointer<LightList>(true);
        int numVMObjects;
        SR1_StructureArrayPointer<VMObject> vmobjectList = new SR1_StructureArrayPointer<VMObject>();
        int numSpotLights;
        SR1_StructureArrayPointer<SpotLight> spotLightList = new SR1_StructureArrayPointer<SpotLight>();
        int numPointLights;
        SR1_StructureArrayPointer<PointLight> pointLightList = new SR1_StructureArrayPointer<PointLight>();
        int numSpotSpecturalLights;
        SR1_StructureArrayPointer<SpotLight> spotSpecturalLightList = new SR1_StructureArrayPointer<SpotLight>();
        int numPointSpecturalLights;
        SR1_StructureArrayPointer<PointLight> pointSpecturalLightList = new SR1_StructureArrayPointer<PointLight>();
        int numBGObjects;
        SR1_StructureArrayPointer<BGObject> bgObjectList = new SR1_StructureArrayPointer<BGObject>();
        int waterZLevel;
        byte backColorR;
        byte backColorG;
        byte backColorB;
        byte cpad1;
        byte specturalColorR;
        byte specturalColorG;
        byte specturalColorB;
        byte cpad2;
        ushort fogFar;
        ushort fogNear;
        ushort spectralFogFar;
        ushort spectralFogNear;
        ushort waterFogFar;
        ushort waterFogNear;
        int depthQBlendStart;
        SR1_Pointer<LightList> spectrallightList = new SR1_Pointer<LightList>(true);
        int numCameras;
        SR1_StructureArrayPointer<CameraKey> cameraList = new SR1_StructureArrayPointer<CameraKey>((parent) => (int)((Level)parent).numCameras); // void in sym, but really a CameraKey
        int bspPlaneError;
        int numVGroups;
        SR1_StructureArrayPointer<VGroup> vGroupList = new SR1_StructureArrayPointer<VGroup>();
        int deathZ;
        int flags;
        SR1_Pointer<MultiSignal> startSignal = new SR1_Pointer<MultiSignal>();
        int numIntros;
        SR1_StructureArrayPointer<Intro> introList = new SR1_StructureArrayPointer<Intro>((parent) => (int)((Level)parent).numIntros);
        SR1_StructureArrayPointer<DrMoveAniTex> bgAniList = new SR1_StructureArrayPointer<DrMoveAniTex>();
        int numHotSpots;
        SR1_StructureArrayPointer<HotSpot> hotSpotList = new SR1_StructureArrayPointer<HotSpot>();
        SR1_Pointer<ObjectNameList> objectNameList = new SR1_Pointer<ObjectNameList>(true);
        int depthQFogStart;
        int morphLastStep;
        SR1_PrimitiveArrayPointer<char> worldName = new SR1_PrimitiveArrayPointer<char>((parent) => 8);
        VramSize vramSize = new VramSize();
        ushort holdFogFar;
        ushort holdFogNear;
        int numberEnemyUnits;
        SR1_PrimitiveArrayPointer<char> enemyUnitsNames = new SR1_PrimitiveArrayPointer<char>();
        SR1_PrimitiveArrayPointer<int> timesSignalList = new SR1_PrimitiveArrayPointer<int>();
        SR1_Pointer<MultiSignal> spectralSignal = new SR1_Pointer<MultiSignal>();
        SR1_Pointer<MultiSignal> materialSignal = new SR1_Pointer<MultiSignal>();
        SR1_Pointer<MultiSignal> startUnitLoadedSignal = new SR1_Pointer<MultiSignal>();
        SR1_Pointer<MultiSignal> startUnitMainSignal = new SR1_Pointer<MultiSignal>();
        SR1_Pointer<MultiSignal> startGoingIntoWaterSignal = new SR1_Pointer<MultiSignal>();
        SR1_Pointer<MultiSignal> startGoingOutOfWaterSignal = new SR1_Pointer<MultiSignal>();
        int unitFlags;
        SR1_StructureSeriesPointer<MultiSignal> SignalListStart = new SR1_StructureSeriesPointer<MultiSignal>((parent) => (int)((Level)parent).SignalListEnd.Offset - (int)((Level)parent).SignalListStart.Offset);
        SR1_Pointer<MultiSignal> SignalListEnd = new SR1_Pointer<MultiSignal>();
        int numBSPLeaves;
        SR1_Pointer<EventPointers> PuzzleInstances = new SR1_Pointer<EventPointers>(true);
        int NumberOfPlanMarkers;
        SR1_StructureArrayPointer<PlanMkr> PlanMarkerList = new SR1_StructureArrayPointer<PlanMkr>();
        int NumberOfSFXMarkers;
        SR1_StructureArrayPointer<SFXMkr> SFXMarkerList = new SR1_StructureArrayPointer<SFXMkr>();
        uint versionNumber;
        SR1_PrimitiveArrayPointer<char> dynamicMusicName = new SR1_PrimitiveArrayPointer<char>((parent) => 4);
        int streamUnitID;
        SR1_StructureArray<TClassAttr> tClassAttr = new SR1_StructureArray<TClassAttr>(16);
        SR1_PrimitiveArray<short> TODLighting = new SR1_PrimitiveArray<short>(4, 3);
        SR1_PrimitiveArray<byte> TODbackColor = new SR1_PrimitiveArray<byte>(4, 3);
        SR1_PrimitiveArray<ushort> TODfogNearFar = new SR1_PrimitiveArray<ushort>(4, 2);
	    short TODRedScale;
        short TODGrnScale;
        short TODBluScale;
        short TODfogNear;
        short TODfogFar;
        short short_pad;
        byte TODbackColorR;
        byte TODbackColorG;
        byte TODbackColorB;
        byte cpad3;
        SR1_Pointer<LightGroup> razielLightGroup = new SR1_Pointer<LightGroup>(true);
        SR1_Pointer<LightGroup> razielSpectralLightGroup = new SR1_Pointer<LightGroup>(true);
    }
}
