﻿using System.Collections.Generic;
using System.IO;

namespace Recombobulator.SR1Structures
{
    class MultiSignal : SR1_Structure
    {
        int numSignals;
        short signalNum;
        short flags;
        SR1_StructureArray<Signal> signalList = new SR1_StructureArray<Signal>(0);

        public override void Read(SortedDictionary<uint, SR1_Structure> dictionary, BinaryReader reader, bool isMember, GoalTracker tracker)
        {
            Start = (uint)reader.BaseStream.Position;
            IsMember = isMember;

            if (!IsMember)
            {
                dictionary.Add(Start, this);
            }

            numSignals = reader.ReadInt32();
            signalNum = reader.ReadInt16();
            flags = reader.ReadInt16();

            signalList = new SR1_StructureArray<Signal>(numSignals);
            signalList.Read(dictionary, reader, true, tracker);

            reader.BaseStream.Position += 4;

            End = (uint)reader.BaseStream.Position;
        }
    }
}
