﻿using System.Collections.Generic;
using System.IO;

namespace Recombobulator.SR1Structures
{
    class StreamUnitPortalList : SR1_Structure
    {
        int numPortals;
        SR1_StructureArray<StreamUnitPortal> portals = new SR1_StructureArray<StreamUnitPortal>(0);

        public override void Read(SortedDictionary<uint, SR1_Structure> dictionary, BinaryReader reader, bool isMember, GoalTracker tracker)
        {
            Start = (uint)reader.BaseStream.Position;
            IsMember = isMember;

            if (!IsMember)
            {
                dictionary.Add(Start, this);
            }

            numPortals = reader.ReadInt32();

            portals = new SR1_StructureArray<StreamUnitPortal>(numPortals);
            portals.Read(dictionary, reader, true, tracker);

            End = (uint)reader.BaseStream.Position;
        }
    }
}
