﻿using System;
using System.Reflection;

namespace Recombobulator.SR1Structures
{
    class Terrain : SR1_Structure
    {
        // Use      //.*\r?\n     to search and remove comments.

        short UnitChangeFlags;
        short spad;
        int lpad2;
        int numIntros;
        SR1_StructureArrayPointer<Intro> introList = new SR1_StructureArrayPointer<Intro>();
        int numVertices;
        int numFaces;
        int numNormals;
        SR1_StructureArrayPointer<TVertex> vertexList = new SR1_StructureArrayPointer<TVertex>((parent) => (int)((Terrain)parent).numVertices);
        SR1_StructureArrayPointer<TFace> faceList = new SR1_StructureArrayPointer<TFace>((parent) => (int)((Terrain)parent).numFaces);
        SR1_StructureArrayPointer<Normal> normalList = new SR1_StructureArrayPointer<Normal>((parent) => (int)((Terrain)parent).numNormals);
        SR1_Pointer<DrMoveAniTex> aniList = new SR1_Pointer<DrMoveAniTex>(true);
        int pad;
        SR1_Pointer<StreamUnitPortalList> StreamUnits = new SR1_Pointer<StreamUnitPortalList>(true); // void in sym, StreamUnitPortalList created for this tool.
        SR1_StructureSeriesPointer<TextureFT3> StartTextureList = new SR1_StructureSeriesPointer<TextureFT3>((parent) => (int)((Terrain)parent).EndTextureList.Offset - (int)((Terrain)parent).StartTextureList.Offset);
        SR1_StructureSeriesPointer<TextureFT3> EndTextureList = new SR1_StructureSeriesPointer<TextureFT3>();
        SR1_StructureSeriesPointer<MorphVertex> MorphDiffList = new SR1_StructureSeriesPointer<MorphVertex>((parent) => (int)((Terrain)parent).MorphColorList.Offset - (int)((Terrain)parent).MorphDiffList.Offset);
        SR1_StructureArrayPointer<MorphColor> MorphColorList = new SR1_StructureArrayPointer<MorphColor>((parent) => (int)((Terrain)parent).numVertices);
        int numBSPTrees;
        SR1_StructureArrayPointer<BSPTree> BSPTreeArray = new SR1_StructureArrayPointer<BSPTree>((parent) => (int)((Terrain)parent).numBSPTrees);
        SR1_PrimitiveArrayPointer<short> morphNormalIdx = new SR1_PrimitiveArrayPointer<short>(); // Not sure if array or pointer.
        SR1_Pointer<MultiSignal> signals = new SR1_Pointer<MultiSignal>();
    };
}
