﻿using System;
using System.Collections.Generic;
using System.IO;

namespace Recombobulator
{
    class SR1_PaddedPrimitiveArray<T> : SR1_PrimitiveArray<T>// where T : struct
    {
        private int _Padding;

        public SR1_PaddedPrimitiveArray(int arrayLength, int padding)
            : base(arrayLength)
        {
            _Padding = padding;
        }

        public override void Read(SortedDictionary<uint, SR1_Structure> dictionary, BinaryReader reader, bool isMember, GoalTracker tracker)
        {
            base.Read(dictionary, reader, isMember, tracker);

            if (_Padding > 1)
            {
                while (((uint)reader.BaseStream.Position - Start) % (uint)_Padding != 0)
                {
                    reader.BaseStream.Position++;
                }
            }

            End = (uint)reader.BaseStream.Position;
        }
    }
}
