﻿using System.IO;

namespace Recombobulator
{
    class SR1_Pointer<T> : ISR1_Pointer where T : class, new()
    {
        private bool _ShouldCreate = false;

        public uint Offset { get; set; }

        public T Object { get { return null; } }

        public object CreateObject(SR1_Structure parent, BinaryReader reader, GoalTracker tracker)
        {
            if (_ShouldCreate)
            {
                if (typeof(T) == typeof(SR1Structures.EventBasicObject))
                {
                    long oldPosition = reader.BaseStream.Position;
                    SR1Structures.EventBasicObject tempEBO = new SR1Structures.EventBasicObject();
                    tempEBO.Read(null, reader, true, tracker);
                    reader.BaseStream.Position = oldPosition;

                    return tempEBO.CreateReplacementObject();
                }

                return new T();
            }

            return null;
        }

        public SR1_Pointer()
        {
        }

        public SR1_Pointer(bool shouldCreate)
        {
            _ShouldCreate = shouldCreate;
        }
    }
}
