﻿using System;
using System.IO;

namespace Recombobulator
{
    class SR1_PointerArrayPointer<T> : ISR1_Pointer where T : SR1_Structure, new()
    {
        private Func<SR1_Structure, int> _CreateFunction;

        private bool _ShouldCreate = false;

        public uint Offset { get; set; }

        public object CreateObject(SR1_Structure parent, BinaryReader reader, GoalTracker tracker)
        {
            if (_CreateFunction != null)
            {
                int arrayLength = _CreateFunction(parent);
                if (arrayLength > 0)
                {
                    return new SR1_PointerArray<T>(arrayLength, _ShouldCreate);
                }
            }

            return null;
        }

        public SR1_PointerArrayPointer()
        {
        }

        public SR1_PointerArrayPointer(Func<SR1_Structure, int> createFunction, bool shouldCreate)
        {
            _CreateFunction = createFunction;
            _ShouldCreate = shouldCreate;
        }
    }
}
