﻿using System;
using System.IO;

namespace Recombobulator
{
    class SR1_PrimitiveArrayPointer<T> : ISR1_Pointer// where T : struct
    {
        private Func<SR1_Structure, int> _CreationFunction;

        private int _Padding = 0;

        public uint Offset { get; set; }

        public object CreateObject(SR1_Structure parent, BinaryReader reader, GoalTracker tracker)
        {
            if (_CreationFunction != null)
            {
                int arrayLength = _CreationFunction(parent);
                return new SR1_PaddedPrimitiveArray<T>(arrayLength, _Padding);
            }

            return null;
        }

        public SR1_PrimitiveArrayPointer()
        {
        }

        public SR1_PrimitiveArrayPointer(Func<SR1_Structure, int> createFunction)
        {
            _CreationFunction = createFunction;
            _Padding = 0;
        }

        public SR1_PrimitiveArrayPointer(Func<SR1_Structure, int> createFunction, int padding)
        {
            _CreationFunction = createFunction;
            _Padding = padding;
        }
    }
}
