﻿using System;
using System.IO;

namespace Recombobulator
{
    class SR1_StructureArrayPointer<T> : ISR1_Pointer where T : SR1_Structure, new()
    {
        private Func<SR1_Structure, int> _CreateFunction;

        public uint Offset { get; set; }

        public object CreateObject(SR1_Structure parent, BinaryReader reader, GoalTracker tracker)
        {
            if (_CreateFunction != null)
            {
                int arrayLength = _CreateFunction(parent);
                return new SR1_StructureArray<T>(arrayLength);
            }

            return null;
        }

        public SR1_StructureArrayPointer()
        {
        }

        public SR1_StructureArrayPointer(Func<SR1_Structure, int> createFunction)
        {
            _CreateFunction = createFunction;
        }
    }
}
