﻿using System;
using System.IO;

namespace Recombobulator
{
    class SR1_StructureSeriesPointer<T> : ISR1_Pointer where T : SR1_Structure, new()
    {
        private Func<SR1_Structure, int> _CreateFunction;

        public uint Offset { get; set; }

        public object CreateObject(SR1_Structure parent, BinaryReader reader, GoalTracker tracker)
        {
            if (_CreateFunction != null)
            {
                int bufferLength = _CreateFunction(parent);
                if (bufferLength > 0)
                {
                    return new SR1_StructureSeries<T>(bufferLength);
                }
            }

            return null;
        }

        public SR1_StructureSeriesPointer()
        {
        }

        public SR1_StructureSeriesPointer(Func<SR1_Structure, int> createFunction)
        {
            _CreateFunction = createFunction;
        }
    }
}
