#!/usr/bin/env python3

import json
import ntpath
import os
import sys

gLineSeparator = "\n"

def WriteToFile(outputFilePath, content):
	outputFile = open(outputFilePath,"a")
	outputFile.write(content)
	outputFile.write(gLineSeparator)
	outputFile.close()

# https://stackoverflow.com/questions/8384737/extract-file-name-from-path-no-matter-what-the-os-path-format
def pathLeaf(path):
    head, tail = ntpath.split(path)
    return tail or ntpath.basename(head)

def ShowUsage():
	print("Usage: %s --input FILE_LIST_FILE --recombobulator PATH_TO_RECOMBOBULATOR --base-output-dir BASE_OUTPUT_DIRECTORY --output OUTPUT_FILE --filetype [alpha|beta|release]" % (sys.argv[0]))
	print(gLineSeparator)

if __name__=='__main__':
	if len(sys.argv) < 3:
		ShowUsage()
		sys.exit(1)
	
	inputListFilePath = ""
	recombobFilePath = ""
	baseOutputDirectory = ""
	outputFilePath = ""
	recombobFileType = ""
	args2 = []
	argNum = 0
	while argNum < len(sys.argv):
		currentArg = sys.argv[argNum]
		foundArg = False
		if argNum < (len(sys.argv) - 1):
			nextArg = sys.argv[argNum + 1]
			if currentArg == "--recombobulator":
				foundArg = True
				recombobFilePath = os.path.abspath(nextArg)
			if foundArg == False:
				if currentArg == "--filetype":
					foundArg = True
					recombobFileType = nextArg
			if foundArg == False:
				if currentArg == "--input":
					foundArg = True
					inputListFilePath = os.path.abspath(nextArg)
			if foundArg == False:
				if currentArg == "--output":
					foundArg = True
					outputFilePath = os.path.abspath(nextArg)
			if foundArg == False:
				if currentArg == "--base-output-dir":
					foundArg = True
					baseOutputDirectory = os.path.abspath(nextArg)
		if foundArg:
				argNum += 2
		if foundArg == False:
			args2.append(currentArg)
			argNum += 1
	
	if inputListFilePath == "" or outputFilePath == "" or baseOutputDirectory == "" or recombobFileType == "" or recombobFilePath == "":
		ShowUsage()
		sys.exit(1)
		
	outputFile = open(outputFilePath,"w")
	#outputFile.write("#!/usr/bin/env python3")
	outputFile.write(gLineSeparator)
	outputFile.close()
	#WriteToFile(outputFilePath, "import bpy")
	#WriteToFile(outputFilePath, gLineSeparator)
	
	with open(inputListFilePath) as inputListFile:
		for line in inputListFile:
			currentInputFilePath = line.strip().replace('\r', '').replace('\n', '')
			areaFileName = pathLeaf(currentInputFilePath)
			dotPos = areaFileName.index(".")
			areaName = areaFileName[0:dotPos]
			convertedFilePath = os.path.join(baseOutputDirectory, "%s.json" % (areaName))
			WriteToFile(outputFilePath, '"%s" --input "%s" --output "%s" --filetype "%s"' % (recombobFilePath, currentInputFilePath, convertedFilePath, recombobFileType))